package demo.modules.one 
{
	import demo.modules.one.views.ModuleOneGame;
	import flash.display.Sprite;
	import org.robotlegs.core.IInjector;
	import org.robotlegs.utilities.modular.core.IModuleContext;
	import starling.core.Starling;
	
	/**
	 * ... 模块一 ...
	 * @author Jerry
	 */
	public class ModuleOne extends Sprite implements IModuleOne
	{
		/**
		 * 模块上下文控制器
		 * @private
		 */
		private var context:IModuleContext;
		
		/**
		 * Starling框架对象
		 * @private
		 */
		private var mStarling:Starling;
		
		/**
		 * Starling容器根节点
		 * @private
		 */
		private var mRootObj:ModuleOneGame;
		
		/**
		 * 构造函数
		 */
		public function ModuleOne() 
		{
			super();
		}
		
		/**
		 * 开发游戏
		 */
		public function startGame(value:IInjector):void 
		{
			mRootObj = new ModuleOneGame();
			context = new ModuleOneContext(mRootObj, true, value);
			mStarling = new Starling(mRootObj, stage);
			mStarling.antiAliasing = 1;
			mStarling.start();
		}
		
		/**
		 * 设置父级注射器
		 */
		[Inject]
		public function set parentInjector(value:IInjector):void
		{
			startGame(value);
		}
		
		/**
		 * 销毁方法
		 */
		public function dispose():void 
		{
			context.dispose();
			context = null;
		}
	}

}