package demo.modules.one 
{
	import demo.common.controllers.events.CommonEvent;
	import demo.modules.one.controllers.commands.MoviePlayFastCommand;
	import demo.modules.one.models.GameModel;
	import demo.modules.one.views.ModuleOneGame;
	import demo.modules.one.views.ModuleOneGameMediator;
	import flash.system.ApplicationDomain;
	import org.robotlegs.core.IInjector;
	import org.robotlegs.utilities.modular.starling.mvcs.StarlingModuleContext;
	import starling.display.DisplayObjectContainer;
	
	/**
	 * ... 模块一上下文控制器 ...
	 * @author Jerry
	 */
	public class ModuleOneContext extends StarlingModuleContext 
	{
		/**
		 * 构造函数
		 * @param	contextView
		 * @param	autoStartup
		 * @param	parentInjector
		 * @param	applicationDomain
		 */
		public function ModuleOneContext(contextView:DisplayObjectContainer=null, autoStartup:Boolean=true, parentInjector:IInjector=null, applicationDomain:ApplicationDomain=null) 
		{
			super(contextView, autoStartup, parentInjector, applicationDomain);
		}
		
		/**
		 * 框架启动
		 */
		override public function startup():void 
		{
			//注册模型
			injector.mapSingleton(GameModel);
			
			//注册控制器
			moduleCommandMap.mapEvent(CommonEvent.MOVIE_PLAY_FAST, MoviePlayFastCommand, CommonEvent);
			
			//注册视图
			mediatorMap.mapView(ModuleOneGame, ModuleOneGameMediator, null, false, false);
			mediatorMap.createMediator(contextView);
		}
	}

}