package demo.modules.one.views 
{
	import demo.common.controllers.events.CommonEvent;
	import demo.models.AppModel;
	import demo.modules.one.models.GameModel;
	import demo.modules.one.views.events.MovieViewEvent;
	import org.robotlegs.utilities.modular.starling.mvcs.StarlingModuleMediator;
	
	/**
	 * ... 模块一游戏中介器 ...
	 * @author Jerry
	 */
	public class ModuleOneGameMediator extends StarlingModuleMediator 
	{
		/**
		 * 应用程序数据模型
		 */
		[Inject]
		public var appMdl:AppModel;
		
		/**
		 * 游戏数据模型
		 */
		[Inject]
		public var gameMdl:GameModel;
		
		/**
		 * 游戏
		 */
		[Inject]
		public var game:ModuleOneGame;
		
		/**
		 * 构造函数
		 */
		public function ModuleOneGameMediator() 
		{
			super();
		}
		
		/**
		 * 注册中介器
		 */
		override public function onRegister():void 
		{
			addViewListener(MovieViewEvent.MOVIE_PLAY, moviePlayHandler, MovieViewEvent);
			trace("应用程序版本号：" + appMdl.appVersion);
			trace("游戏版本号：" + gameMdl.gameVersion);
			game.start();
		}
		
		/**
		 * 影片剪辑播放事件
		 * @private
		 * @param	e
		 */
		private function moviePlayHandler(e:MovieViewEvent):void 
		{
			dispatchToModules(new CommonEvent(CommonEvent.MOVIE_PLAY));
		}
	}

}