package demo.modules.one.views 
{
	import demo.modules.one.views.events.MovieViewEvent;
	import flash.media.Sound;
	import starling.core.Starling;
	import starling.display.MovieClip;
	import starling.display.Sprite;
	import starling.events.Event;
	import starling.textures.Texture;
	
	/**
	 * ... 影片场景 ...
	 * @author Jerry
	 */
	public class MovieScene extends Sprite 
	{
		/**
		 * 影片
		 * @priva
		 */
		private var mMovie:MovieClip;
		
		/**
		 * 构造函数
		 */
		public function MovieScene() 
		{
			super();
			
			Assets.prepareSounds();
            Assets.loadBitmapFonts();
			
			var frames:Vector.<Texture> = Assets.getTextureAtlas().getTextures("flight");
            mMovie = new MovieClip(frames, 24);
			
			var stepSound:Sound = Assets.getSound("Step");
            mMovie.setFrameSound(2, stepSound);
			mMovie.stop();
			addChild(mMovie);
			
			addEventListener(Event.ADDED_TO_STAGE, onAddedToStage);
            addEventListener(Event.REMOVED_FROM_STAGE, onRemovedFromStage);
		}
		
		private function onAddedToStage(event:Event):void
        {
            Starling.juggler.add(mMovie);
			mMovie.play();
			dispatchCommonEvent(new MovieViewEvent(MovieViewEvent.MOVIE_PLAY));
        }
        
        private function onRemovedFromStage(event:Event):void
        {
            Starling.juggler.remove(mMovie);
        }
        
        public override function dispose():void
        {
            removeEventListener(Event.REMOVED_FROM_STAGE, onRemovedFromStage);
            removeEventListener(Event.ADDED_TO_STAGE, onAddedToStage);
            super.dispose();
        }
		
		public function stop():void 
		{
			mMovie.pause();
		}
		
		public function playFast():void 
		{
			mMovie.fps = 60;
		}
	}

}