package demo.views 
{
	import com.greensock.events.LoaderEvent;
	import com.greensock.loading.SWFLoader;
	import demo.common.controllers.events.CommonEvent;
	import org.robotlegs.utilities.modular.mvcs.ModuleMediator;
	
	/**
	 * ... 主视图中介器 ...
	 * @author Jerry
	 */
	public class StarlingRobotlegsMediator extends ModuleMediator 
	{
		/**
		 * 主视图
		 */
		[Inject]
		public var view:StarlingModularRobotlegs;
		
		/**
		 * 构造函数
		 */
		public function StarlingRobotlegsMediator() 
		{
			super();
		}
		
		/**
		 * 注册事件完成
		 */
		override public function onRegister():void 
		{
			trace("主视图中介器初始化完成！");
			
			//加载模块一
			var loader:SWFLoader = new SWFLoader("ModuleOne.swf", { auditSize:false, onComplete: moduleLoaded } );
			loader.load();
			
			addModuleListener(CommonEvent.MOVIE_PLAY, moviePlayHandler, CommonEvent);
		}
		
		/**
		 * 影片播放事件
		 * @private
		 * @param	e
		 */
		private function moviePlayHandler(e:CommonEvent):void 
		{
			trace("主模块接收到模块一消息，影片已播放");
			dispatchToModules(new CommonEvent(CommonEvent.MOVIE_PLAY_FAST));
		}
		
		/**
		 * 模块加载完毕
		 * @private
		 * @param	e
		 */
		private function moduleLoaded(e:LoaderEvent):void 
		{
			var loader:SWFLoader = e.target as SWFLoader;
			view.addChild(loader.content);
		}
	}

}