package org.robotlegs.utilities.modular.starling.mvcs 
{
	import flash.events.Event;
	import org.robotlegs.mvcs.StarlingMediator;
	import org.robotlegs.utilities.modular.core.IModuleCommandMap;
	import org.robotlegs.utilities.modular.core.IModuleEventDispatcher;
	
	/**
	 * ... The module mediator for Starling engine ...
	 * @author Jerry
	 */
	public class StarlingModuleMediator extends StarlingMediator 
	{
		[Inject]
		public var moduleDispatcher:IModuleEventDispatcher;
	   		
		[Inject]
		public var moduleCommandMap:IModuleCommandMap;
		
		/**
		 * Construtor Method
		 */
		public function StarlingModuleMediator() 
		{
			super();
		}
		
		/**
         * Map an event type to globally redispatch to all modules within an application.
         * <p/>
         * <listing version="3.0">
         * mapRedispatchToModules(MyEvent.SOME_EVENT);
         * </listing>
         * 
         * @param event
         * 
         */
        protected function addModuleListener(type:String, listener:Function, eventClass:Class = null, useCapture:Boolean = false, priority:int = 0, useWeakReference:Boolean = true):void
        {
            eventMap.mapListener(moduleDispatcher, type, listener, eventClass, useCapture, priority, useWeakReference);
        }
        
        /**
         * Globally redispatch an event to all modules within an application.
         * <p/>
         * <listing version="3.0">
         * eventMap.mapEvent(view, MyEvent.SOME_EVENT, redispatchToModule);
         * </listing>
         * 
         * @param event
         * 
         */
		protected function dispatchToModules(event:Event):Boolean
        {
            if(moduleDispatcher.hasEventListener(event.type))
			    return moduleDispatcher.dispatchEvent(event);
            return false;
		}
	}

}